## gl-image-display 0.10

=== debian/changelog ===
gl-image-display (0.10-2) unstable; urgency=medium

  * Fixed incorrect debian/copyright attribution

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Apr 2022 15:04:17 -0700

gl-image-display (0.10-1) unstable; urgency=medium

  * Initial release (Closes: #1008282)

 -- Dima Kogan <dkogan@debian.org>  Fri, 25 Mar 2022 14:12:30 -0700

## gl-image-display 0.11

=== Makefile ===
include mrbuild/Makefile.common.header

PROJECT_NAME := GL_image_display
ABI_VERSION  := 0
TAIL_VERSION := 1

LDLIBS += \
  -lGLU -lGL -lepoxy -lglut \
  -lfreeimage \
  -lm \
  -pthread

CFLAGS    += --std=gnu99
CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-parameter

################# library ###############
LIB_SOURCES := GL_image_display.c
GL_image_display.o: $(foreach w,image line,$(foreach t,vertex geometry fragment,$w.$t.glsl.h))

%.glsl.h: %.glsl
	( echo '#version 420'; cat $<; ) | sed 's/.*/"&\\n"/g' > $@.tmp && mv $@.tmp $@

EXTRA_CLEAN += *.glsl.h

BIN_SOURCES += \
  GL_image_display-test-glut.c


################ FLTK widget library #############
# This is mostly a copy of the library logic in mrbuild. mrbuild currently
# doesn't support more than one DSO per project, so I duplicate that logic here
# for the second library
LIB_SOURCES_FLTK := Fl_Gl_Image_Widget.cc
LIB_OBJECTS_FLTK := $(addsuffix .o,$(basename $(LIB_SOURCES_FLTK)))
LIB_NAME_FLTK           = libGL_image_display_fltk
LIB_TARGET_SO_BARE_FLTK = $(LIB_NAME_FLTK).so
LIB_TARGET_SO_ABI_FLTK  = $(LIB_TARGET_SO_BARE_FLTK).$(ABI_VERSION)
LIB_TARGET_SO_FULL_FLTK = $(LIB_TARGET_SO_ABI_FLTK).$(TAIL_VERSION)
LIB_TARGET_SO_ALL_FLTK  = $(LIB_TARGET_SO_BARE_FLTK) $(LIB_TARGET_SO_ABI_FLTK) $(LIB_TARGET_SO_FULL_FLTK)
$(LIB_OBJECTS_FLTK): CCXXFLAGS += -fPIC
$(LIB_TARGET_SO_FULL_FLTK): LDFLAGS += -shared $(LD_DEFAULT_SYMVER) -fPIC -Wl,-soname,$(notdir $(LIB_TARGET_SO_BARE_FLTK)).$(ABI_VERSION)  -Wl,-rpath='$$ORIGIN'$(call get_parentdir_relative_to_childdir,$(abspath .),$(dir $(abspath $@)))
$(LIB_TARGET_SO_BARE_FLTK) $(LIB_TARGET_SO_ABI_FLTK): $(LIB_TARGET_SO_FULL_FLTK)
	ln -fs $(notdir $(LIB_TARGET_SO_FULL_FLTK)) $@
$(LIB_TARGET_SO_FULL_FLTK): $(LIB_OBJECTS_FLTK)
	$(CC_LINKER) $(LDFLAGS) $(filter %.o, $^) $(filter-out %.o, $^) $(LDLIBS) -o $@
all: $(LIB_TARGET_SO_ALL_FLTK)
install: install_lib_fltk
.PHONY: install_lib_fltk
install_lib_fltk: $(LIB_TARGET_SO_ALL_FLTK)
	mkdir -p $(DESTDIR)/$(USRLIB)
	cp -P $(LIB_TARGET_SO_FULL_FLTK)  $(DESTDIR)/$(USRLIB)
	chrpath -d $(DESTDIR)/$(USRLIB)/$(LIB_TARGET_SO_FULL_FLTK)
	ln -fs $(notdir $(LIB_TARGET_SO_FULL_FLTK)) $(DESTDIR)/$(USRLIB)/$(notdir $(LIB_TARGET_SO_ABI_FLTK))
	ln -fs $(notdir $(LIB_TARGET_SO_FULL_FLTK)) $(DESTDIR)/$(USRLIB)/$(notdir $(LIB_TARGET_SO_BARE_FLTK))

$(LIB_TARGET_SO_FULL_FLTK): lib$(PROJECT_NAME).so
$(LIB_TARGET_SO_FULL_FLTK): LDLIBS += -lfltk_gl -lfltk -lX11

############### FLTK test application ############
BIN_SOURCES += \
  GL_image_display-test-fltk.cc
CXXFLAGS_FLTK := $(shell fltk-config --use-images --cxxflags)
CXXFLAGS += $(CXXFLAGS_FLTK)

GL_image_display-test-fltk: $(LIB_TARGET_SO_FULL_FLTK)
GL_image_display-test-fltk: LDLIBS += -lfltk_gl -lfltk -lX11

############### FLTK widget Python wrapper ############
install all: Fl_Gl_Image_Widget.py _Fl_Gl_Image_Widget$(PY_EXT_SUFFIX)
%.py %_pywrap.cc: %.i
	swig \
	  -w302 -w312 -w325 -w362 -w389 -w401 -w473 -w509 \
	  -I/usr/include/ \
	  -DFL_EXPORT \
	  -DPYTHON \
	  -DPYTHON3 \
	  -py3 \
	  -python \
	  -c++ \
	  -keyword \
	  -shadow \
	  -fastdispatch \
	  -outdir . \
	  -o $*_pywrap.cc \
	  $<

EXTRA_CLEAN += *_pywrap.cc
Fl_Gl_Image_Widget.py Fl_Gl_Image_Widget_pywrap.cc: Fl_Gl_Image_Widget.hh

Fl_Gl_Image_Widget_pywrap.o: CXXFLAGS += $(PY_MRBUILD_CFLAGS)
_Fl_Gl_Image_Widget$(PY_EXT_SUFFIX): Fl_Gl_Image_Widget_pywrap.o $(LIB_TARGET_SO_FULL_FLTK)
	$(PY_MRBUILD_LINKER) $(LDFLAGS) $(PY_MRBUILD_LDFLAGS) -Wl,-rpath=$$ORIGIN/ $^ -o $@

# The python libraries (compiled ones and ones written in python) all live in
# mrcal/
DIST_PY3_MODULES := Fl_Gl_Image_Widget.py _Fl_Gl_Image_Widget$(PY_EXT_SUFFIX)

DIST_INCLUDE := \
  Fl_Gl_Image_Widget.hh \
  GL_image_display.h

# I don't ship any binaries
DIST_BIN := ""

DIST_DOC := \
  GL_image_display-test-fltk.cc \
  GL_image_display-test-fltk.py \
  GL_image_display-test-glut.c


include mrbuild/Makefile.common.footer

=== debian/changelog ===
gl-image-display (0.11-1build1) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as supported

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 03 Nov 2022 15:45:20 +0000

gl-image-display (0.11-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Wed, 03 Aug 2022 12:08:59 -0700

## gl-image-display 0.16

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 GL_image_display.o: $(foreach w,image line,$(foreach t,vertex geometry fragment,$w.$t.glsl.h))
 
 %.glsl.h: %.glsl
-	( echo '#version 420'; cat $<; ) | sed 's/.*/"&\\n"/g' > $@.tmp && mv $@.tmp $@
+	< $< sed 's/.*/"&\\n"/g' > $@.tmp && mv $@.tmp $@
 
 EXTRA_CLEAN += *.glsl.h
 
@@ -67,7 +67,7 @@
 
 ############### FLTK widget Python wrapper ############
 install all: Fl_Gl_Image_Widget.py _Fl_Gl_Image_Widget$(PY_EXT_SUFFIX)
-%.py %_pywrap.cc: %.i
+%.py %_pywrap.h %_pywrap.cc: %.i
 	swig \
 	  -w302 -w312 -w325 -w362 -w389 -w401 -w473 -w509 \
 	  -I/usr/include/ \
@@ -84,7 +84,7 @@
 	  -o $*_pywrap.cc \
 	  $<
 
-EXTRA_CLEAN += *_pywrap.cc
+EXTRA_CLEAN += Fl_Gl_Image_Widget.py *_pywrap.h *_pywrap.cc
 Fl_Gl_Image_Widget.py Fl_Gl_Image_Widget_pywrap.cc: Fl_Gl_Image_Widget.hh
 
 Fl_Gl_Image_Widget_pywrap.o: CXXFLAGS += $(PY_MRBUILD_CFLAGS)

=== debian/changelog ===
gl-image-display (0.16-1) unstable; urgency=medium

  * New upstream release
    - Turned off double buffering

 -- Dima Kogan <dkogan@debian.org>  Thu, 03 Nov 2022 21:33:15 -0700

gl-image-display (0.15.1-1) unstable; urgency=medium

  * New upstream release
    - Minor build updates for old distros

 -- Dima Kogan <dkogan@debian.org>  Tue, 27 Sep 2022 01:02:50 -0700

gl-image-display (0.15-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 26 Sep 2022 23:52:24 -0700

gl-image-display (0.13-1) unstable; urgency=medium

  * New upstream release:
    - Added more missing make_current() calls
    - New user-accessible flip_x, flip_y flags
 -- Dima Kogan <dkogan@debian.org>  Thu, 22 Sep 2022 16:51:07 -0700

gl-image-display (0.12-1) unstable; urgency=medium

  * New upstream release: OpenGL 3.3 supported

 -- Dima Kogan <dkogan@debian.org>  Mon, 19 Sep 2022 23:39:25 -0700

=== debian/control ===
Source: gl-image-display
Priority: optional
Section: devel
Build-Depends:
# Please do not "fix" to use debhelper-compat. I want this to remain compatible
# with older debian-based distros
 debhelper (>= 11),
 dh-python,
 swig,
 libgl1-mesa-dev,
 libepoxy-dev,
 libfltk1.3-dev,
 libfreeimage-dev,
 freeglut3-dev,
 python3-numpy,
 python3-all-dev:any,
 libpython3-all-dev,
 python3,
 chrpath
Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.0
Homepage:    https://www.github.com/dkogan/GL_image_display
Vcs-Git: https://salsa.debian.org/debian/gl-image-display.git
Vcs-Browser: https://salsa.debian.org/debian/gl-image-display

Package: libgl-image-display0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenGL-based image visualizer
 A library to render images with OpenGL. After the initial load, the panning and
 zooming is done in hardware, with zero CPU cost. This package provides the
 runtime C libraries and the binaries for the C++ FLTK widget

Package: libgl-image-display-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libgl-image-display0 (= ${binary:Version})
Description: OpenGL-based image visualizer
 A library to render images with OpenGL. After the initial load, the panning and
 zooming is done in hardware, with zero CPU cost. This package provides the
 headers for the C libraries and for the C++ FLTK widget

Package: python3-gl-image-display
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgl-image-display0 (= ${binary:Version}),
         ${python3:Depends},
         python3-fltk,
         python3-numpy
Provides: ${python3:Provides}
Description: OpenGL-based image visualizer
 A library to render images with OpenGL. After the initial load, the panning and
 zooming is done in hardware, with zero CPU cost. This package provides the
 Python implementation of the FLTK widget

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3

# I build the python libraries for all the available python versions. The
# non-Python stuff shouldn't be rebuilt because Make should see that it's
# up-to-date
override_dh_auto_build:
	for v in `py3versions -s | sed s/python//g`; do		\
	  rm -f *pywrap*.o;					\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_build;	\
	done

# Similarly, I install everything, looping through all the available python
# versions, which could be more than just the default. All the non-python stuff
# will be installed multiple times, but it's the same files going to the same
# paths, so it hurts nothing
override_dh_auto_install:
	for v in `py3versions -s | sed s/python//g`; do		\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_install;	\
	done

override_dh_python3:
	dh_numpy3
	dh_python3

# skip tests if asked
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	true
endif

## gl-image-display 0.17

=== debian/changelog ===
gl-image-display (0.17-1build1) noble; urgency=medium

  * No-change rebuild to build with python3.12 as supported.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Nov 2023 09:20:24 +0100

gl-image-display (0.17-1) unstable; urgency=medium

  * New upstream release
    - Double-buffering is switchable at constructor time. Default is
      DOUBLE-buffered. This can break rendering on i915 hardware
  
 -- Dima Kogan <dkogan@debian.org>  Sat, 30 Sep 2023 13:12:20 -0700

## gl-image-display 0.18

=== debian/changelog ===
gl-image-display (0.18-1) unstable; urgency=medium

  * New upstream release
    - Silenced benign warnings

 -- Dima Kogan <dkogan@debian.org>  Fri, 26 Apr 2024 22:38:36 -0700

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  python3-all-dev:any,
  libpython3-all-dev,
  python3,
- chrpath
+ mrbuild
 Maintainer: Dima Kogan <dkogan@debian.org>
 Standards-Version: 4.6.0
 Homepage:    https://www.github.com/dkogan/GL_image_display

## gl-image-display 0.20

=== debian/changelog ===
gl-image-display (0.20-2) unstable; urgency=medium

  * Culled Build-Depends for cross-building

 -- Dima Kogan <dkogan@debian.org>  Thu, 17 Oct 2024 06:00:58 -0700

gl-image-display (0.20-1) unstable; urgency=medium

  * New upstream release
    - flip_x/flip_y are respected everywhere: in set_line() and when
      loading an image file
    - I don't ask for FL_OPENGL3: this fixes rendering issues on hardware
      with Intel integrated graphics
     - update_image() draws a black image if image_filename==NULL &&
      image_data==NULL

 -- Dima Kogan <dkogan@debian.org>  Wed, 18 Sep 2024 11:55:36 -0700

gl-image-display (0.19-2) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080615)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 21:53:30 -0700

gl-image-display (0.19-1) unstable; urgency=medium

  * New upstream release
    - Early Fl_Gl_Image_Widget.set_lines() calls can be deferred
    - The Fl_Gl_Image_Widget can't appear focused

 -- Dima Kogan <dkogan@debian.org>  Sat, 24 Aug 2024 21:12:52 -0700

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,9 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080615
+ python3-setuptools,
  swig,
  libgl1-mesa-dev,
  libepoxy-dev,
@@ -13,9 +16,7 @@
  libfreeimage-dev,
  freeglut3-dev,
  python3-numpy,
- python3-all-dev:any,
- libpython3-all-dev,
- python3,
+ libpython3-dev,
  mrbuild
 Maintainer: Dima Kogan <dkogan@debian.org>
 Standards-Version: 4.6.0

## gl-image-display 0.21

=== debian/changelog ===
gl-image-display (0.21-1) unstable; urgency=medium

  * New upstream release
    - Reverted "The Fl_Gl_Image_Widget can't appear focused"

 -- Dima Kogan <dkogan@debian.org>  Sun, 22 Dec 2024 14:54:02 -0800

## gl-image-display 0.21.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
-include mrbuild/Makefile.common.header
+include choose_mrbuild.mk
+include $(MRBUILD_MK)/Makefile.common.header
 
 PROJECT_NAME := GL_image_display
 ABI_VERSION  := 0
@@ -71,10 +72,9 @@
 	swig \
 	  -w302 -w312 -w325 -w362 -w389 -w401 -w473 -w509 \
 	  -I/usr/include/ \
-	  -DFL_EXPORT \
+	  -DFL_EXPORT="" \
 	  -DPYTHON \
 	  -DPYTHON3 \
-	  -py3 \
 	  -python \
 	  -c++ \
 	  -keyword \
@@ -108,4 +108,4 @@
   GL_image_display-test-glut.c
 
 
-include mrbuild/Makefile.common.footer
+include $(MRBUILD_MK)/Makefile.common.footer

=== debian/changelog ===
gl-image-display (0.21.1-2build2) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 28 Jan 2025 11:24:38 +0000

gl-image-display (0.21.1-2build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:02:42 +0100

gl-image-display (0.21.1-2) unstable; urgency=medium

  * New upstream release to fix broken import of 0.21
    - This is the same thing as the real 0.21 tag, but different from the
    erroneous 0.21-1 debian release

 -- Dima Kogan <dkogan@debian.org>  Sun, 22 Dec 2024 20:14:36 -0800

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+ dh-sequence-python3,
 # for "make install" to work. See
 #   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080615
  python3-setuptools,

## gl-image-display 0.22

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
  swig,
  libgl1-mesa-dev,
  libepoxy-dev,
- libfltk1.3-dev,
+ libfltk1.4-dev,
+ libcairo2-dev,
  libfreeimage-dev,
  freeglut3-dev,
  python3-numpy,
@@ -50,7 +51,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libgl-image-display0 (= ${binary:Version}),
          ${python3:Depends},
-         python3-fltk,
+         python3-fltk (>> 1.4),
          python3-numpy
 Provides: ${python3:Provides}
 Description: OpenGL-based image visualizer

## gl-image-display 0.23

=== Makefile ===
--- 
+++ 
@@ -73,6 +73,7 @@
 	  -w302 -w312 -w325 -w362 -w389 -w401 -w473 -w509 \
 	  -I/usr/include/ \
 	  -DFL_EXPORT="" \
+	  -DFL_OVERRIDE="" \
 	  -DPYTHON \
 	  -DPYTHON3 \
 	  -python \

=== debian/changelog ===
gl-image-display (0.23-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sat, 10 May 2025 12:35:24 -0700

gl-image-display (0.22-2) unstable; urgency=medium

  * Added forgotten build-depend: libcairo2-dev

 -- Dima Kogan <dkogan@debian.org>  Fri, 11 Apr 2025 23:29:38 -0700

gl-image-display (0.22-1) unstable; urgency=medium

  * New upstream release
    Moving to fltk 1.4

 -- Dima Kogan <dkogan@debian.org>  Thu, 10 Apr 2025 10:15:29 -0700

=== debian/watch ===
version=4
https://github.com/dkogan/GL_image_display/tags .*/v?(\d\S+)\.tar\.gz

## gl-image-display 0.24

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 LDLIBS += \
   -lGLU -lGL -lepoxy -lglut \
-  -lfreeimage \
+  -lstb \
   -lm \
   -pthread

=== debian/changelog ===
gl-image-display (0.24-2) unstable; urgency=medium

  * Build-Depends: python3-numpy-dev. Cross-building works now

 -- Dima Kogan <dkogan@debian.org>  Thu, 01 Jan 2026 23:33:11 -0800

gl-image-display (0.24-1) unstable; urgency=medium

  * New upstream release: libfreeimage -> libstb

 -- Dima Kogan <dkogan@debian.org>  Wed, 24 Dec 2025 23:26:52 -0800

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,9 @@
  libepoxy-dev,
  libfltk1.4-dev,
  libcairo2-dev,
- libfreeimage-dev,
+ libstb-dev,
  freeglut3-dev,
- python3-numpy,
+ python3-numpy-dev,
  libpython3-dev,
  mrbuild
 Maintainer: Dima Kogan <dkogan@debian.org>
